# -*- coding: utf-8 -*-
import math

class IntersegmentDistanceTable:
    def __init__(self, segments):
        self.m = dict()
        for i in segments:
            self.m[i.transcription] = dict()
            for j in segments:
                self.m[i.transcription][j.transcription]=self.compute_segment_distance(i,j)

    def get(self, i, j):
        return self.m[i][j]

    # /* compute a distance between segments - unweighted */
    def compute_segment_distance(segment1, segment2):
        dist = float(0)

        for data_point_1, data_point_2 in zip(segment1.data, segment2.data):
            d = (data_point_1 - data_point_2)
            dist += d * d

        dist = math.sqrt(dist / len(segment1.data))

        return dist