# -*- coding: utf-8 -*-
import re

class Segment:
    def __init__(self, speaker, segment, data):
        self.speaker = speaker
        self.transcription = segment
        self.data = [float(i) for i in data]
        self.unicode_transcription = self.get_unicode()

    def __str__(self):
        return "%s %s %s %s" % (self.speaker.accent, self.speaker.gender, self.transcription, self.speaker.id)

    def __repr__(self):
        return str(self)

    def get_unicode(self):
        conversion_dictionary = {"an":"ã", "ax":"a̰", "ah":"a̤", "oe":"œ", "a":"a", "c":"ɔ", "w":"ɯ", "g":"ɤ", "j":"ɨ", "3":"ɛ", "y":"y", "o":"o", "u":"u", "i":"i", "e":"e", "@":"ə"}
        result = re.search(r"(.*)(\/[ptksn])([^ptks]*?)([ptksn])([^ptksn][^ptks]*?)$", self.transcription)
        #for i in range(1,6):  #Test statement
        #    print(result.group(i))
        return "{}{}{}{}{}".format(conversion_dictionary[result.group(1)],result.group(2), conversion_dictionary[result.group(3)],result.group(4), conversion_dictionary[result.group(5)])