# -*- coding: utf-8 -*-
import IntersegmentDistanceTable


class Speaker:
    def __init__(self, id, accent, gender):
        self.id = id
        self.accent = accent
        self.gender = gender
        self.segments = []
        self.intersegment_distance_table = None

    def set_segments(self, segments):
        self.segments = segments

    def set_intersegment_distance_table(self):
        if self.intersegment_distance_table is None:
            self.intersegment_distance_table = IntersegmentDistanceTable(self.segments)

    def __eq__(self, other):
        if isinstance(other, self.__class__):
            return self.id == other.id
        return False

    def __str__(self):
        return self.id