# -*- coding: utf-8 -*-
from ACCDIST.vowel_distance import Transcription

def print_table(table, description, is_float, f):
    headers = "\t"
    header_complete = False
    rows = []
    for row_name in sorted(table.keys()):
        row = row_name + "\t"
        for column_name in sorted(table[row_name].keys()):
            value = table[row_name][column_name]
            if value is not None:
                if is_float:
                    row += "%f\t" % value
                else:
                    row += "%d\t" % value
            if not header_complete:
                headers += column_name
                headers += "\t"
        rows.append(row)
        header_complete = True

    f.write(description+"\n")
    f.write(headers+"\n")
    for row in rows:
        f.write(row+"\n")

def print_phylip_table(table, f):
    rows = []
    for row_name in sorted(table.keys()):
        row = "{:<10}".format(row_name)
        for column_name in sorted(table[row_name].keys()):
            value = table[row_name][column_name]
            if value is not None:
                    row += "%f\t" % value
        rows.append(row)

    f.write("{}\n".format(len(rows)))
    for row in rows:
        f.write(row.rstrip()+"\n")

def print_list(table, f):
    rows = []
    for row_name in sorted(table.keys()):
        for column_name in sorted(table[row_name].keys()):
            value = table[row_name][column_name]
            if value is not None:
                row = "{}\t{}\t{}\t{}\t{}".format(row_name, Transcription(row_name).unicode_vowel, column_name, Transcription(column_name).unicode_vowel, value)
            rows.append(row)

    for row in rows:
        f.write(row.rstrip()+"\n")

def print_speaker_list(table, speakers, description, f):
    f.write(description+"\n")
    for s1 in table:
        for s2 in table:
            speaker1 = [s for s in speakers if s.id == s1][0]
            speaker2 = [s for s in speakers if s.id == s2][0]
            f.write("%s\t%s\t%s\t%s\t%s\t%s\t%s\n" % (
            s1, speaker1.accent, speaker1.gender, s2, speaker2.accent, speaker2.gender,
            table[s1][s2]))