class VowelComparisonTable:
    def __init__(self, transcriptions):
        self.table = dict()
        for transcription in transcriptions:
            self.table[transcription] = dict()
            self.table[transcription][transcription] = None

    def __getitem__(self, item):
        return self.table[item]


class VowelPairDistance:
    def __init__(self, transcription1, transcription2, value):
        self.vowel1 = Transcription(transcription1).vowel
        self.vowel2 = Transcription(transcription2).vowel
        self.value = value


class VowelPair:
    def __init__(self, a, b):
        self.vowel1 = a
        self.vowel2 = b

    def __repr__(self):
        return self.vowel1 + "," + self.vowel2

    def __eq__(self, other):
        return self.vowel1 == other.vowel1 and self.vowel2 == other.vowel2

    def __hash__(self):
        return hash(self.vowel1) + hash(self.vowel2)


class Transcription:
    def __init__(self, raw):
        parts = raw.split("/")
        conversion_dictionary = {"an": "ã", "ax": "a̰", "ah": "a̤", "oe": "œ", "a": "a", "c": "ɔ", "w": "ɯ", "g": "ɤ",
                                 "j": "ɨ", "3": "ɛ", "y": "y", "o": "o", "u": "u", "i": "i", "e": "e", "@": "ə"}
        self.vowel = parts[0]
        self.unicode_vowel = conversion_dictionary[self.vowel]
        #self.word = parts[1]